;
; Macro file for MSDOS.
;

subttl break a listing into pages and give new subtitles
page
break macro subtitle
 subttl subtitle
 page
endm

break <i_need: declare a variable external, if necessary, and allocate a size>

;
; declare a variable external and allocate a size
;
i_need macro sym,len
 data segment word public 'DATA'
 ifidn <len>,<word>
 extrn &sym:word
 else
 ifidn <len>,<dword>
 extrn &sym:dword
 else
 extrn &sym:byte
 endif
 endif
 data ends
endm

;
; call a procedure that may be external. The call will be short.
;
invoke macro name
.xcref
 if2
 ifndef name
 extrn name:near
 endif
 endif
.cref
 call name
endm

page
;
; jump to a label that may be external. The jump will be near.
;
transfer macro name
.xcref
 if2
 ifndef name
 extrn name:near
 endif
 endif
.cref
 jump name
endm

;
; get a short address in a word
;
short_addr macro name
 ifdif <name>,<?>
.xcref
 if2
 ifndef name
 extrn name:near
 endif
 endif
.cref
 dw offset dosgroup:name
 else
 dw ?
 endif
endm

;
; get a long address in a dword
;
long_addr macro name
.xcref
 if2
 ifndef name
 extrn name:near
 endif
.cref
 dd name
endm

;
; declare a PROC near or far but PUBLIC nonetheless
;
procedure macro name,distance
 public name
name proc distance
endm

page
;
; define a data item to be public and of an appropriate size/type
;
i_am macro name,size
 public name

 ifidn <size>,<word>
name dw ?
 else
 ifidn <size>,<dword>
name dd ?
 else
 ifidn <size>,<byte>
name db ?
 else
name db size dup (?)
 endif
 endif
 endif
endm

page
;
; call the macro chain
;
do_ext macro
endm

page

;
; define an entry in a procedure
;
entry macro name
 public name
name:
endm

break <error - print a message and then jump to a label>

error macro code
 local a
.xcref
 mov al,code
 transfer sys_ret_err
.cref
endm

break <jump - real jump that links up shortwise>
;
; given a label <lbl> either 2 byte jump to another label <lbl>_J
; if it is near enough or 3 byte jump to <lbl>
;

jump macro lbl
 local a
.xcref
 a:
 ifndef lbl&_j ;; is this the first invocation
 jmp lbl
 else
 if lbl&_j ge $
 jmp lbl
 else
 if ($-lbl&_j) gt 126 ;; is the jump too far away?
 jmp lbl
 else ;; do the short one...
 jmp lbl&_j
 endif
 endif
 endif
 lbl&_j = a
.cref
endm

break <return - return from a function>

return macro
 local a
.xcref
a:
 ret
ret_l = a
.cref
endm

break <condret - conditional return>

makelab macro l,cc,ncc
 local a
 j&ncc a ;; j<NCC> a:
 return ;; return
 a: ;; a:
 ret_&cc = ret_l ;; define ret_<CC> to be ret_l
endm

condret macro cc,ncc
 local a,b
 ifdef ret_l ;; if ret_l is defined
 if (($ - ret_l) le 126) and ($ gt ret_l)
 ;; if ret_l is near enough then
 a: j&cc ret_l ;; a: j<CC> to ret_l
 ret_&cc = a ;; define ret_<CC> to be a:
 else
 makelab a,cc,ncc
 endif
 else
 ifdef ret_&cc ;; if ret_<CC> defined
 if (($ - ret_&cc) le 126) and ($ gt ret_&cc)
 ;; if ret_<CC> is near enough
 a: j&cc ret_&cc ;; a: j<CC> to ret_<CC>
 ret_&cc = a ;; define ret_<CC> to be a:
 else
 makelab a,cc,ncc
 endif
 else
 makelab a,cc,ncc
 endif
 endif
endm
;condret macro cc,ncc
; local a,b
; ifdef ret_l ; if ret_l is defined
; if (($ - ret_l) le 126) and ($ gt ret_l)
; ; if ret_l is near enough then
; a: j&cc ret_l ; a: j<CC> to ret_l
; ret_&cc = a ; define ret_<CC> to be a:
; exitm
; endif
; endif
; ifdef ret_&cc ; if ret_<CC> defined
; if (($ - ret_&cc) le 126) and ($ gt ret_&cc)
; ; if ret_<CC> is near enough
; a: j&cc ret_&cc ; a: j<CC> to ret_<CC>
; ret_&cc = a ; define ret_<CC> to be a:
; exitm
; endif
; endif
; j&ncc a ; j<NCC> a:
; return ; return
; a: ; a:
; ret_&cc = ret_l ; define ret_<CC> to be ret_l
;endm
;
break <retz - return if zero, links up shortwise if necessary>

retz macro
 condret z,nz
endm

break <retnz - return if not zero, links up shortwise if necessary>

retnz macro
 condret nz,z
endm

break <retc - return if carry set, links up shortwise if necessary>

retc macro
 condret c,nc
endm

break <retnc - return if not carry, links up shortwise if necessary>

retnc macro
 condret nc,c
endm

break <context - set the dos context to a particular register>

context macro r
 push ss
 pop r
 assume r:dosgroup
endm
